{
  "categories" : {"top": "Top", "io" : "I/O", "schema" : "Schema", "problems" : "Problematic Statements", "waits": "Waits", "innodb" : "InnoDB"},
  "reports" : [

  {"category" : "io",
   "view" : "io_global_by_file_by_bytes",
   "description" : "Show the top global IO consumers by bytes usage by file",
   "caption" : "Top I/O by File by Bytes",
   "columns" : [["File", "String", 200],
                ["Reads", "LongInteger", 80],
                ["Total Read", "NumberWithUnit", 80],
                ["Avg Read", "NumberWithUnit", 80],
                ["Writes", "LongInteger", 80],
                ["Total Written", "NumberWithUnit", 80],
                ["Avg Written", "NumberWithUnit", 80],
                ["Total", "NumberWithUnit", 80],
                ["Write %", "String", 80]]
  },

  { "category" : "io",
    "view" : "io_global_by_file_by_latency",
    "description" : "Show the top global IO consumers by latency by file",
    "caption" : "Top I/O by File by Latency",
    "columns" : [["File", "String", 200],
                 ["Total # of Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Read #", "LongInteger", 80],
                 ["Read Latency", "NumberWithUnit", 80],
                 ["Write #", "LongInteger", 80],
                 ["Write Latency", "NumberWithUnit", 80],
                 ["Misc #", "LongInteger", 80],
                 ["Misc Latency", "NumberWithUnit", 80]]
  },

  {"category" : "io",
   "view" : "io_global_by_wait_by_bytes",
   "description" : "Show the top global IO consumer classes by bytes usage",
   "caption" : "Top I/O by Wait by Bytes",
   "columns" : [["Event", "String", 200],
                ["Total # of Events", "LongInteger", 80],
                ["Total Latency", "NumberWithUnit", 80],
                ["Min Latency", "NumberWithUnit", 80],
                ["Avg Latency", "NumberWithUnit", 80],
                ["Max Latency", "NumberWithUnit", 80],
                ["Reads", "NumberWithUnit", 80],
                ["Avg Read", "NumberWithUnit", 80],
                ["Writes", "LongInteger", 80],
                ["Total Written", "NumberWithUnit", 80],
                ["Avg Written", "NumberWithUnit", 80],
                ["Total Requested", "NumberWithUnit", 80]]
  },

  {"category" : "io",
   "view" : "io_global_by_wait_by_latency",
   "description" : "Show the top global IO consumers by latency",
   "caption" : "Top I/O by Wait by Latency",
   "columns" : [["Event", "String", 200],
                ["Total # of Events", "LongInteger", 80],
                ["Total Latency", "NumberWithUnit", 80],
                ["Min Latency", "NumberWithUnit", 80],
                ["Avg Latency", "NumberWithUnit", 80],
                ["Max Latency", "NumberWithUnit", 80],
                ["Read Latency", "NumberWithUnit", 80],
                ["Write Latency", "NumberWithUnit", 80],
                ["Misc Latency", "NumberWithUnit", 80],
                ["Reads", "NumberWithUnit", 80],
                ["Avg Read", "NumberWithUnit", 80],
                ["Writes", "LongInteger", 80],
                ["Total Written", "NumberWithUnit", 80],
                ["Avg Written", "NumberWithUnit", 80]]
  },

  { "category" : "io",
    "view" : "io_by_thread_by_latency",
    "description" : "Show the top IO consumers by thread, ordered by total latency",
    "caption" : "Top I/O by Thread by Latency",
    "columns" : [["User", "String", 150],
                 ["Total # of Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Min Latency", "NumberWithUnit", 80],
                 ["Avg Latency", "NumberWithUnit", 80],
                 ["Max Latency", "NumberWithUnit", 80],
                 ["Thread Id", "LongInteger", 80],
                 ["Process List Id", "LongInteger", 80]]
  },

  { "category" : "top",
    "view" : "ps_top_worst_latency",
    "limit" : 10,
    "description" : "",
    "caption" : "Top 10 Worst Latency",
    "columns" : [["Table Name", "String", 200],
               ["Total # Events", "LongInteger", 80],
               ["Total Latency", "NumberWithUnit", 80],
               ["Average Latency", "NumberWithUnit", 80],
               ["Maximum Latency", "NumberWithUnit", 80]]
  },

  {"category" : "top",
  "view" : "ps_top_active_tables",
  "limit" : 10,
  "description" : "",
  "caption" : "Top 10 Most Active Tables",
  "columns" : [["Table Name", "String", 200],
              ["Total # Events", "LongInteger", 80]]
  },

  { "category" : "problems",
    "view" : "statement_analysis",
    "description" : "Lists a normalized statement view with aggregated statistics, mimics the MySQL Enterprise Monitor Query Analysis view, ordered by the total execution time per normalized statement",
    "caption" : "Statement Analysis",
    "columns" : [["Query", "String", 300],
                 ["Full Scan", "String", 80],
                 ["# Executed", "LongInteger", 80],
                 ["# Errors", "LongInteger", 80],
                 ["# Warnings", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Maximum Latency", "NumberWithUnit", 80],
                 ["Average Latency", "NumberWithUnit", 80],
                 ["Rows Sent", "LongInteger", 80],
                 ["Avg. Rows Sent", "LongInteger", 80],
                 ["Rows Scanned", "LongInteger", 80],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "problems",
    "view" : "statements_with_runtimes_in_95th_percentile",
    "description" : "List all statements who's average runtime, in microseconds, is in the top 95th percentile",
    "caption" : "Runtimes in 95th Percentile",
    "columns" : [["Query", "String", 300],
                 ["Full Table Scan", "String", 50],
                 ["# Executed", "LongInteger", 80],
                 ["# Errors", "LongInteger", 80],
                 ["# Warnings", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Maximum Latency", "NumberWithUnit", 80],
                 ["Average Latency", "NumberWithUnit", 80],
                 ["Rows Sent", "LongInteger", 80],
                 ["Avg. Rows Sent", "LongInteger", 80],
                 ["Rows Scanned", "LongInteger", 80],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "problems",
    "view" : "statements_with_temp_tables",
    "description" : "Lists all normalized statements that use temporary tables ordered by number of on disk temporary tables descending first, then by the number of memory tables",
    "caption" : "Using Temp Tables",
    "columns" : [["Query", "String", 300],
                 ["# Executed", "LongInteger", 80],
                 ["# Tmp Tables (memory)", "LongInteger", 80],
                 ["# Tmp Tables (disk)", "LongInteger", 80],
                 ["Avg. Tmp Tables/Query", "LongInteger", 80],
                 ["Tmp Tables to Disk %", "String", 80],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "problems",
    "view" : "statements_with_sorting",
    "description" : "List all normalized statements that have done sorts, ordered by sort_merge_passes, sort_scans and sort_rows, all descending",
    "caption" : "With Sorting",
    "columns" : [["Query", "String", 300],
                 ["# Executed", "LongInteger", 80],
                 ["Sort Merge Passes", "LongInteger", 80],
                 ["Avg. Sort Merges", "LongInteger", 80],
                 ["Sorts Using Scans", "LongInteger", 80],
                 ["Sorts Using Range", "LongInteger", 80],
                 ["Rows Sorted", "LongInteger", 80],
                 ["Avg. Rows Sorted", "LongInteger", 80],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "problems",
    "view" : "statements_with_full_table_scans",
    "description" : "Lists all normalized statements that use have done a full table scan ordered by number the percentage of times a full scan was done, then by the number of times the statement executed",
    "caption" : "Full Table Scans",
    "columns" : [["Query", "String", 300],
                 ["# Executed", "LongInteger", 80],
                 ["No Index Used", "LongInteger", 80],
                 ["No Good Index Used", "LongInteger", 80],
                 ["No Index Used %", "String", 80],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "problems",
    "view" : "statements_with_errors_or_warnings",
    "description" : "List all normalized statements that have raised errors or warnings.",
    "caption" : "Errors or Warnings",
    "columns" : [["Query", "String", 300],
                 ["# Executed", "LongInteger", 80],
                 ["Errors", "LongInteger", 80],
                 ["Error %", "String", 50],
                 ["Warnings", "LongInteger", 80],
                 ["Warnings %", "String", 50],
                 ["Digest", "String", 100]
                 ]
  },

  { "category" : "schema",
    "view" : "schema_object_overview",
    "description" : "Shows an overview of the types of objects within each schema.\nNote: On instances with a large number of objects, this could take some time to execute, and is not recommended.",
    "caption" : "Schema Object Overview",
    "columns" : [["Schema", "String", 150],
                 ["Object Type", "String", 150],
                 ["Count", "LongInteger", 80]
                 ]
  },


  { "category" : "schema",
    "view" : "schema_index_statistics",
    "description" : "",
    "caption" : "Schema Index Statistics",
    "columns" : [["Schema", "String", 100],
                 ["Table", "String", 100],
                 ["Index", "String", 100],
                 ["Rows Selected", "LongInteger", 80],
                 ["Select Latency", "NumberWithUnit", 80],
                 ["Rows Inserted", "LongInteger", 80],
                 ["Insert Latency", "NumberWithUnit", 80],
                 ["Rows Updated", "LongInteger", 80],
                 ["Update Latency", "NumberWithUnit", 80],
                 ["Rows Deleted", "LongInteger", 80],
                 ["Delete Latency", "NumberWithUnit", 80]
                 ]
  },

  { "category" : "schema",
    "view" : "schema_table_statistics",
    "description" : "",
    "caption" : "Schema Table Statistics",
    "columns" : [["Schema", "String", 100],
                 ["Table", "String", 100],
                 ["Rows Fetched", "LongInteger", 80],
                 ["Fetch Latency", "NumberWithUnit", 80],
                 ["Rows Inserted", "LongInteger", 80],
                 ["Insert Latency", "NumberWithUnit", 80],
                 ["Rows Updated", "LongInteger", 80],
                 ["Update Latency", "NumberWithUnit", 80],
                 ["Rows Deleted", "LongInteger", 80],
                 ["Delete Latency", "NumberWithUnit", 80],
                 ["I/O Read Reqs.", "LongInteger", 80],
                 ["I/O Read", "NumberWithUnit", 80],
                 ["I/O Read Latency", "NumberWithUnit", 80],
                 ["I/O Write Reqs.", "LongInteger", 80],
                 ["I/O Write", "NumberWithUnit", 80],
                 ["I/O Write Latency", "NumberWithUnit", 80],
                 ["I/O Misc. Reqs.", "LongInteger", 80],
                 ["I/O Misc. Latency", "NumberWithUnit", 80]
                 ]
  },

  { "category" : "schema",
    "view" : "schema_table_statistics_with_buffer",
    "description" : "",
    "caption" : "Schema Table Statistics (with InnoDB buffer)",
    "columns" : [["Schema", "String", 100],
                 ["Table", "String", 100],
                 ["Rows Fetched", "LongInteger", 80],
                 ["Fetch Latency", "NumberWithUnit", 80],
                 ["Rows Selected", "LongInteger", 80],
                 ["Select Latency", "NumberWithUnit", 80],
                 ["Rows Inserted", "LongInteger", 80],
                 ["Insert Latency", "NumberWithUnit", 80],
                 ["Rows Updated", "LongInteger", 80],
                 ["Update Latency", "NumberWithUnit", 80],
                 ["Rows Deleted", "LongInteger", 80],
                 ["Delete Latency", "NumberWithUnit", 80],
                 ["I/O Read Reqs.", "LongInteger", 80],
                 ["I/O Read", "NumberWithUnit", 80],
                 ["I/O Read Latency", "NumberWithUnit", 80],
                 ["I/O Write Reqs.", "LongInteger", 80],
                 ["I/O Write", "NumberWithUnit", 80],
                 ["I/O Write Latency", "NumberWithUnit", 80],
                 ["I/O Misc. Reqs.", "LongInteger", 80],
                 ["I/O Misc. Latency", "NumberWithUnit", 80],
                 ["Buffer Allocated", "NumberWithUnit", 80],
                 ["Buffer Data", "NumberWithUnit", 80],
                 ["Buffer Pages", "LongInteger", 80],
                 ["Buffer Pages Hashed", "LongInteger", 80],
                 ["Buffer Pages Old", "LongInteger", 80],
                 ["Buffer Rows Cached", "LongInteger", 80]
                 ]
  },

  { "category" : "schema",
    "view" : "schema_tables_with_full_table_scans",
    "description" : "Find tables that are being accessed by full table scans ordering by the number of rows scanned descending",
    "caption" : "Tables with Full Table Scans",
    "columns" : [["Schema", "String", 100],
                 ["Object", "String", 100],
                 ["Rows Full Scanned", "LongInteger", 80]]
  },

   {"category" : "schema",
    "view" : "schema_unused_indexes",
    "description" : "List of indexes that were never used since the server started or since P_S data collection started.",
    "caption" : "Unused Indexes",
    "columns" : [["Schema", "String", 100],
                 ["Object", "String", 100],
                 ["Index", "String", 100]]
  },

  { "category" : "wait",
    "view" : "waits_global_by_latency",
    "description" : "Lists the top wait events by their total latency, ignoring idle (this may be very large)",
    "caption" : "Waits by Latency",
    "columns" : [["Event Class", "String", 200],
                 ["Total # Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Avg Latency", "NumberWithUnit", 80],
                 ["Max Latency", "NumberWithUnit", 80]]
  },

  { "category" : "wait",
    "view" : "waits_by_user_by_latency",
    "description" : "Lists the top wait events by their total latency, ignoring idle (this may be very large)",
    "caption" : "Waits by User by Latency",
    "columns" : [["User", "String", 200],
                 ["Event", "String", 200],
                 ["Total # Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Avg Latency", "NumberWithUnit", 80],
                 ["Max Latency", "NumberWithUnit", 80]]
  },

  { "category" : "wait",
    "view" : "wait_classes_global_by_latency",
    "description" : "Lists the top wait classes by total latency, ignoring idle (this may be very large)",
    "caption" : "Wait Classes by Latency",
    "columns" : [["Event Class", "String", 200],
                 ["Total # Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Avg Latency", "NumberWithUnit", 80],
                 ["Max Latency", "NumberWithUnit", 80]]
  },

  { "category" : "wait",
    "view" : "wait_classes_global_by_avg_latency",
    "description" : "Lists the top wait classes by average latency, ignoring idle (this may be very large)",
    "caption" : "Waits Classes by Average Latency",
    "columns" : [["Event Class", "String", 200],
                 ["Total # Events", "LongInteger", 80],
                 ["Total Latency", "NumberWithUnit", 80],
                 ["Avg Latency", "NumberWithUnit", 80],
                 ["Max Latency", "NumberWithUnit", 80]]
  },

  { "category" : "innodb",
  "view" : "innodb_buffer_stats_by_schema",
  "description" : "Summarizes the output of the INFORMATION_SCHEMA.INNODB_BUFFER_PAGE table, aggregating by schema",
  "caption" : "InnoDB Buffer Stats by Schema",
  "columns" : [["Schema", "String", 200],
              ["Allocated", "NumberWithUnit", 80],
              ["Data", "NumberWithUnit", 80],
              ["Pages", "LongInteger", 80],
              ["Pages Hashed", "LongInteger", 80],
              ["Pages Old", "LongInteger", 80],
              ["Rows Cached", "String", 80]
              ]
  },
               
  { "category" : "innodb",
  "view" : "innodb_buffer_stats_by_table",
  "description" : "Summarizes the output of the INFORMATION_SCHEMA.INNODB_BUFFER_PAGE table, aggregating by schema and table name",
  "caption" : "InnoDB Buffer Stats by Table",
  "columns" : [["Schema", "String", 200],
              ["Table", "String", 200],
              ["Allocated", "NumberWithUnit", 80],
              ["Data", "NumberWithUnit", 80],
              ["Pages", "LongInteger", 80],
              ["Pages Hashed", "LongInteger", 80],
              ["Pages Old", "LongInteger", 80],
              ["Rows Cached", "String", 80]
              ]
  }
]
}
